<template>
  <div>
    <div>
<CModal
            title="Info"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>


<CCardBody>
     <h5>MHE Master</h5>
   
     <CDataTable
      :items="items" 
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="5"
      pagination
      hover
      striped 
      border
      sorter
     >
   

<!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >
      <CButton size="sm" color="info" class="ml-1"  @click="ShowUpdateModal=true; SelectMHE(item)"> Update </CButton>
      <CButton size="sm" color="danger" class="ml-1" @click="ShowDeleteModal=true; SelectMHE(item)" >Delete</CButton>
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectMHE(item)"> Details </CButton>
    </template>

    </CDataTable>
      <CButton size="sm" color="info" class="" @click="ShowAddModal=true"> New MHE</CButton>
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title"> New MHE</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-7">
<form action="#" method="POST">

<!-- <div class="form-group">
<input type="text" name="mhE_Id" class="form-control form-control-sm" placeholder="MHE Id" v-model="newMHE.mhE_Id">
</div> -->


<div class="form-group"><label  >MHE Name</label>
<input type="text" name="mhE_Name" class="form-control form-control-sm"  v-model="newMHE.mhE_Name">
</div>
<div class="form-group">
   <label for="workCent_Id">Work Center</label>
 <select class="form-control" v-model="newMHE.workCent_Type">
     <option v-for="item in wcitems" :value="item.workCentType_Id" :key="item.workCentType_Id">{{ item.workCentType_Name }} </option>
  </select>
</div>

 <div class="form-group"><label  >MHE Type</label>
<!-- <input type="text" name="mhE_Type" class="form-control form-control-sm"   v-model="newMHE.mhE_Type"> -->
<select class="form-control form-control-sm" id="workCent_Type"  v-model="newMHE.mhE_Type"><option value="LeafTruck" >LeafTruck</option> <option value="SW">SW</option></select> 

</div>
<!-- <div class="form-group"><label  >Work Center Type</label>
 
<input type="text" name="workCent_Type" class="form-control form-control-sm" placeholder="workCent_Type"  v-model="newMHE.workCent_Type">
</div>  -->
<!-- <div class="form-group"><label  >Max Capacity</label>
<input type="text" name="max_Capacity" class="form-control form-control-sm" placeholder="Max Capacity"  v-model="newMHE.max_Capacity">
</div>
<div class="form-group"><label  >Unit Of Measurement</label>
<input type="text" name="unit_Of_Measurement" class="form-control form-control-sm" placeholder="Unit Of Measurement"  v-model="newMHE.unit_Of_Measurement">
</div> -->

<div class="form-group">
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;addMHE();" > Add MHE </CButton>
</div>

</form>
 </div>
</div>
</div>
 </div>

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">MHE Details</h5>
    <button type="button" class="close"  @click="ShowDetailsModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body p-4">

<form action="#" method="POST">
<div class="form-group"><label  >MHE Id</label>
<input type="text" name="mhE_Id" readonly class="form-control form-control-sm"  v-model="CurrentMHE.mhE_Id">
</div>


<div class="form-group"><label  >MHE Name</label>
<input type="text" name="mhE_Name" readonly class="form-control form-control-sm" v-model="CurrentMHE.mhE_Name">
</div>

<div class="form-group"><label  >MHE Type</label>
<input type="text" name="mhE_Type" readonly class="form-control form-control-sm"   v-model="CurrentMHE.mhE_Type">
</div>

<div class="form-group"><label  >Work Center Type</label>
<input type="text" name="workCent_Type" readonly class="form-control form-control-sm"   v-model="CurrentMHE.workcentertype">
</div> 
<!-- <div class="form-group"><label  >Max Capacity</label>
<input type="text" name="max_Capacity" readonly class="form-control form-control-sm" placeholder="max_Capacity"  v-model="CurrentMHE.max_Capacity">
</div>
<div class="form-group"><label  >Unity Of Measurement</label>
<input type="text" name="unit_Of_Measurement" readonly class="form-control form-control-sm" placeholder="unit_Of_Measurement"  v-model="CurrentMHE.unit_Of_Measurement">
</div> -->

<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowDetailsModal=false;" > Close </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update MHE</h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">
<div class="form-group"><label  >MHE Id</label>
<input type="text" name="mhE_Id" readonly class="form-control form-control-sm"  v-model="CurrentMHE.mhE_Id">
</div>

<!-- <div class="form-group">
   <label for="workCent_Id">Work Center</label>
 <select class="form-control" v-model="CurrentMHE.workCent_Id">
     <option v-for="item in wcitems" :value="item.workCent_Id" :key="item.workCent_Id">{{ item.workCent_Name }} </option>
  </select>
</div> -->
<div class="form-group"><label  >MHE Name</label>
<input type="text" name="mhE_Name" class="form-control form-control-sm"  v-model="newMHE.mhE_Name">
</div>

<div class="form-group"><label  >MHE Type</label>
<select class="form-control form-control-sm" id="workCent_Type"  v-model="newMHE.mhE_Type"><option value="LeafTruck" >LeafTruck</option> <option value="SW">SW</option></select> 

</div> 

<div class="form-group">
   <label for="workCent_Id">Work Center</label>
 <select class="form-control" v-model="newMHE.workCent_Type">
     <option v-for="item in wcitems" :value="item.workCentType_Id" :key="item.workCentType_Id">{{ item.workCentType_Name }} </option>
  </select>
</div>
<!-- <div class="form-group"><label  >Work Center Type</label>
 
<input type="text" name="workCent_Type" class="form-control form-control-sm" placeholder="workCent_Type"  v-model="newMHE.workCent_Type">
</div>  -->
<!-- <div class="form-group">
<input type="text" name="mhE_Status" class="form-control form-control-sm" placeholder="mhE_Status"  v-model="CurrentMHE.mhE_Status">
</div> -->
<!-- <div class="form-group"><label>Max Capacity</label>
<input type="text" name="max_Capacity" class="form-control form-control-sm" placeholder="max_Capacity"  v-model="CurrentMHE.max_Capacity">
</div>
<div class="form-group"><label  >Unit Of Measurement</label>
<input type="text" name="unit_Of_Measurement" class="form-control form-control-sm" placeholder="unit_Of_Measurement"  v-model="CurrentMHE.unit_Of_Measurement">
</div> -->

<div class="form-group">
<button class="btn btn-info btn-block btn-sm"  @click="ShowUpdateModal=false;UpdateMHE();" > Update MHE </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete MHE</h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the MHE ? </h4>
<h5> You are deleting {{ this.CurrentMHE.mhE_Id +' || '+ this.CurrentMHE.mhE_Name }}</h5>
<hr>
<button class="btn btn-danger btn-sm" @click="ShowDeleteModal=false; deleteItem();"> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-sm" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>

<script>
const items = [

             //{ key: 'mhE_Id', },
             { key: 'mhE_Name', },
            { key: 'mhE_Type',  }, 
            { key: 'workcentertype',     },
             //{ key: 'max_Capacity',   },
            // { key: 'unit_Of_Measurement',     },
  
 ]   
const apigetworkcenter = 'Trace_WorkCenterType_Master/'
const apiget =  'Trace_MHE_Master/'
//import CTableWrapper from '.@/Table.vue' 
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
   //components: { CTableWrapper },
  data ()
  {
     return {
    items: items.map((item, id) => { return {...item, id}}),
    
     fields: [
       // { key: 'show_details1',  label: '',  _style: 'width:1%', },
            
             //{ key: 'mhE_Id',             label:' Id',  _style: 'width:1%',  },
             { key: 'mhE_Name',           label:' Name',    },
            { key: 'mhE_Type',           label:' Type',   }, 
            { key: 'workcentertype',         label:' Work Center',   },
            // { key: 'max_Capacity',       label:' Max Capacity',      _style: 'min-width:50px;'  },
            // { key: 'unit_Of_Measurement',label:'MHE unit Of Measurement',     _style: 'width:1%',  },
                 { key: 'show_details',  label: '',  _style: 'width:30%', },    
      ],
   
  details: [],
  collapseDuration: 0,
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentMHE:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
  wcitems:"",
  newMHE: {mhE_Id:0,mhE_Name:"",mhE_Type:"",mhE_Status:0,max_Capacity:0,workCent_Type:"",unit_Of_Measurement:"",status:1}, }
  },


  
  mounted()
  {
  this.getAllMHEDetails();
  this.getAllWorkCenter();
  },

  methods:
  {
   getAllMHEDetails: function()
   {

   Vue.axios.get(this.$url + apiget)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items =response.data.filter(x => x.status == 1);
       // this.subitems = response.data.fgS_FIFO_MHE_Type_Master;

       }
    });
   },
  getAllWorkCenter: function()
   {
    // alert(this.$url + apigetworkcenter)
 
   Vue.axios.get(this.$url + apigetworkcenter)
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.wcitems = response.data.filter(x => x.status == 1);
 
       }
    });
   },

  addMHE()
  {
 
    if(this.items.find(x => x.mhE_Name == this.newMHE.mhE_Name && x.status == 1 ))
    {

     this.SuccessMsg= "MHE Name " + this.newMHE.mhE_Name +" already exist. Please try another Name";
     this.smallModal = true;
     this.ShowAddModal = true;
    }
    else if(this.newMHE.mhE_Name =="" || this.newMHE.mhE_Type=="" || this.newMHE.workCent_Type=="")
    {
       this.SuccessMsg= " Please enter all fields";
      this.smallModal = true;
      this.ShowAddModal = true;
    }

     // this.validate()
    else
     {


    Vue.axios.post(this.$url + apiget ,this.newMHE).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
      
        this.SuccessMsg ="Records Inserted Successfully.."
        this.getAllMHEDetails();
          location.reload();
       }
    })
    }
   },

  UpdateMHE()
  { 
    if(this.CurrentMHE.mhE_Name != this.newMHE.mhE_Type)
    {
 
       if(this.items.find(x => x.mhE_Name == this.newMHE.mhE_Name && x.status == 1 ))
       {
         this.SuccessMsg= "MHE Name " + this.newMHE.mhE_Name +" already exist. Please try another Name";
         this.smallModal = true;
         this.ShowAddModal = true;
       }
     }
    else if(this.CurrentMHE.mhE_Name =="" || this.CurrentMHE.mhE_Type==""|| this.CurrentMHE.workCent_Type=="")
    {
       this.SuccessMsg= " Please enter all fields";
        this.smallModal = true;
       this.ShowAddModal = true;
    }

     // this.validate()
    else
     {
  
      Vue.axios.put(this.$url + apiget+this.CurrentMHE.mhE_Id,this.CurrentMHE).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
         this.SuccessMsg ="Records Updated Successfully.."
         this.getAllMHEDetails();
           location.reload();
       }
    })}
   },

  deleteItem()
    {
      var mhE_Id = this.CurrentMHE.mhE_Id;
        axios({   method: 'delete',
           url: this.$url + apiget+ mhE_Id
    });
        this.SuccessMsg="MHE Status Changed to Inactive Succesfully"
        this.smallModal = true;
       this.getAllMHEDetails();
       location.reload();
    },
      
  SelectMHE(MHE)
    {
     this.CurrentMHE=MHE;
    },
    
  validate()
  {
   if(this.items.find(x => x.mhE_Name == this.newMHE.mhE_Name && x.status == 1 ))
    {
     this.SuccessMsg= "MHE Name " + this.newMHE.mhE_Name +" already exist. Please try another Name";
     this.smallModal = true;
     this.ShowAddModal = true;
    }
    else if(this.newMHE.mhE_Name =="" || this.newMHE.mhE_Type=="")
    {
      this.SuccessMsg= " Please enter all fields";
     this.smallModal = true;
      this.ShowAddModal = true;
    }



  }

    
    },
  
    

}
</script>

<style scoped>
#overlay{
  position:fixed;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>